// Cut.cpp: implementation of the CCut class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "File Cutter.h"
#include "File CutterDlg.h"
#include "Cut.h"
#include "math.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCut::CCut()
{

}

CCut::~CCut()
{

}

typedef int* IntArrayPtr;

void CCut::FileCutOperations(CString FileToCut, int Cut_Size, CString CutFolder)
{
	CFile infile;
	CFile outfile;
	CFileException e;
	short *buffer;
	int read;
	int BLOCK_SIZE = 2000;
	int stop = 0;	
	int nBytesWrote = 0;
	int counter = 0;

	int FileSize;
	char FileSizeConverted[20];
	char FilesNumberConverted[20];
	CString FileNameChanged;
	CString FileName;
	CString FileNamePath;
	int FileNameLenght;
	CString output_transfer_name;
	char counterConvert[2];
	double divide_size;
	double divide_Cut_Size;
	double divide_FileSize;

	if(infile.Open(FileToCut, CFile::modeRead | CFile::typeBinary))
	{
		FileSize = infile.GetLength();				//Retrives file size
		FileName = infile.GetFileName();
		FileNameLenght = FileName.GetLength();
		FileNamePath = infile.GetFilePath();		//Retrives file path
	}
	else
	{
		if(e.m_cause == CFileException::fileNotFound)
			AfxMessageBox("File Not Found");
		else
			AfxMessageBox("Opening file failed");
		return;
	}

	divide_Cut_Size = Cut_Size;
	divide_FileSize = FileSize;
	
	if(divide_FileSize < divide_Cut_Size)
	{
		AfxMessageBox("File cutting size is greater than size of accutal file.");
		return;
	}

	divide_size = divide_FileSize / divide_Cut_Size;
	double Ddivide = ceil(divide_size);
	int Idivide;
	Idivide = (int)Ddivide;

	int x = FileName.Find(".");
	if( -1 == x)
	{
		FileName = infile.GetFileName();
		FileNameLenght = FileName.GetLength();	//Retrives file size
		output_transfer_name = FileName;
	}
	else
	{
		FileNameChanged = FileName.Left((FileNameLenght + x) - FileNameLenght);
		output_transfer_name = FileNameChanged;
	}


	CString m_OutfileName = CutFolder + "\\" + output_transfer_name + ".FC1";

 	
	if(!outfile.Open(m_OutfileName, CFile::modeWrite | CFile::modeCreate | CFile::typeBinary, &e))
	{
		AfxMessageBox("The output files were not created");
		return;
	}

	sprintf(FileSizeConverted, "%d", FileSize);
	sprintf(FilesNumberConverted, "%d", Idivide);
	CString	FileText = "NAME&TYPE:" + FileName + " SIZE:" + FileSizeConverted + " FILENAME:" + output_transfer_name + " FILES:" + FilesNumberConverted;
	int FileTextSize = FileText.GetLength();

	outfile.Write(FileText, FileTextSize);

	outfile.Close();

	IntArrayPtr a;
	a = new int[Idivide];
	if(a == NULL)
	{
		AfxMessageBox("Error: Insufficient Memory.");
		return;
	}
	
	
	buffer = (short*)malloc(BLOCK_SIZE * sizeof(short));
	if( buffer == NULL )
		AfxMessageBox( "Insufficient memory available for buffer\n" );   

	CString FileNames[10];
	
	for(int i=1; i<(Idivide+1); i++)
	{
		sprintf(counterConvert, "%i", (i+1));
		CString SavingFiles = CutFolder + "\\" + FileNameChanged + ".FC" + counterConvert;
		
		if(!outfile.Open(SavingFiles, CFile::modeWrite | CFile::modeCreate | CFile::typeBinary, &e))
		{
			AfxMessageBox("The output files were not created");
			return;
		}
		
		
		while(stop == 0)
		{
			read = infile.Read(buffer, sizeof(short) * BLOCK_SIZE);
			if ((read == 0)|| (nBytesWrote >= Cut_Size))
			{	
				if(read == 0)
				{
					delete [] a;
					outfile.Close();
					free(buffer);
					nBytesWrote = 0;
					return;
				}
				if(nBytesWrote >= Cut_Size)
				{
					outfile.Close();
					break;
				}
			}

			outfile.Write(buffer, sizeof(short) * (read/2));	
			nBytesWrote += (sizeof(short) * (read/2));
		}
		nBytesWrote = 0;
	}
	outfile.Close();
	free(buffer);
}
