// File CutterDlg.cpp : implementation file
//

#include "stdafx.h"
#include "File Cutter.h"
#include "File CutterDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFileCutterDlg dialog

CFileCutterDlg::CFileCutterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFileCutterDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFileCutterDlg)
	m_Cut_File = _T("");
	m_Join_Start_File = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFileCutterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFileCutterDlg)
	DDX_Control(pDX, IDC_COMBO_SIZE, m_Size);
	DDX_Control(pDX, IDC_OPERATION_BUTTON, m_Operation_Button);
	DDX_Text(pDX, IDC_FILE_CUT, m_Cut_File);
	DDX_Text(pDX, IDC_JOIN_START, m_Join_Start_File);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFileCutterDlg, CDialog)
	//{{AFX_MSG_MAP(CFileCutterDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1_BROWSE, OnButtonCutBrowse)
	ON_BN_CLICKED(IDC_BUTTON2_BROWSE, OnButtonJoinStartBrowse)
	ON_BN_CLICKED(IDC_RADIO_CUT, OnRadioCut)
	ON_BN_CLICKED(IDC_RADIO_JOIN, OnRadioJoin)
	ON_BN_CLICKED(IDC_OPERATION_BUTTON, OnOperationButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFileCutterDlg message handlers

BOOL CFileCutterDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	m_dropEdit_Cut.SubclassDlgItem(IDC_FILE_CUT, this);
	m_dropEdit_Cut.SetUseDir(FALSE);
	m_dropEdit_Cut.SetWindowText("");
	
	m_dropEdit_JoinStart.SubclassDlgItem(IDC_JOIN_START, this);
	m_dropEdit_JoinStart.SetUseDir(FALSE);
	m_dropEdit_JoinStart.SetWindowText("");

	CheckRadioButton(IDC_RADIO_CUT, IDC_RADIO_JOIN, IDC_RADIO_CUT);

	OnRadioCut(); 
	m_Cut_File = "C:\\Eddie Murphy - Raw.mp3";
	m_Join_Start_File = "C:\\Eddie Murphy - Raw.FC1";
	m_Size.SetCurSel(5);
	UpdateData(FALSE);

	m_CuttingSizes[0] = 1048576;
	m_CuttingSizes[1] = 1457600;
	m_CuttingSizes[2] = 2097152;
	m_CuttingSizes[3] = 3145728;
	m_CuttingSizes[4] = 4194304;
	m_CuttingSizes[5] = 5242880;
	m_CuttingSizes[6] = 6291456;
	m_CuttingSizes[7] = 7340032;
	m_CuttingSizes[8] = 8388608;
	m_CuttingSizes[9] = 9437184;
	m_CuttingSizes[10] = 10485760;
	m_CuttingSizes[11] = 15728640;
	m_CuttingSizes[12] = 26214400;
	m_CuttingSizes[13] = 52428800;
	m_CuttingSizes[14] = 78643200;
	m_CuttingSizes[15] = 104857600;

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFileCutterDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFileCutterDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CFileCutterDlg::OnButtonCutBrowse() 
{
	CFileDialog *pDlg;
	int result;
	CString dir = "c:\\*.*";
	char BASED_CODE szFilter[] = "All Files (*.*)|*.*||";

	pDlg = new CFileDialog(TRUE, NULL, dir, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter, NULL );
	
	if (!pDlg)
		return;

	result = pDlg->DoModal();

	if (result == IDOK)
		m_Cut_File = pDlg->GetPathName();
	else
	DWORD error = GetLastError();

	delete pDlg;
	UpdateData(FALSE);	
}

void CFileCutterDlg::OnButtonJoinStartBrowse() 
{
	CFileDialog *pDlg;
	int result;
	CString dir = "c:\\*.FC1";
	char BASED_CODE szFilter[] = "Start File (*.FC1)|*.FC1|All Files (*.*)|*.*||";

	pDlg = new CFileDialog(TRUE, NULL, dir, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter, NULL );
	
	if (!pDlg)
		return;

	result = pDlg->DoModal();

	if (result == IDOK)
		m_Join_Start_File = pDlg->GetPathName();
	else
	DWORD error = GetLastError();

	delete pDlg;
	UpdateData(FALSE);		
}

void CFileCutterDlg::OnRadioCut() 
{
	GetDlgItem(IDC_CUT_BOX)->EnableWindow(TRUE);
	GetDlgItem(IDC_STATIC_CUT)->EnableWindow(TRUE);
	GetDlgItem(IDC_FILE_CUT)->EnableWindow(TRUE);
	GetDlgItem(IDC_BUTTON1_BROWSE)->EnableWindow(TRUE);
	GetDlgItem(IDC_STATIC_SIZE)->EnableWindow(TRUE);
	GetDlgItem(IDC_COMBO_SIZE)->EnableWindow(TRUE);
	
	GetDlgItem(IDC_JOIN_BOX)->EnableWindow(FALSE);
	GetDlgItem(IDC_STATIC_JOIN_START)->EnableWindow(FALSE);
	GetDlgItem(IDC_JOIN_START)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON2_BROWSE)->EnableWindow(FALSE);
	
	
	
	m_Operation_Button.SetWindowText("Cut File");
}

void CFileCutterDlg::OnRadioJoin() 
{
	GetDlgItem(IDC_CUT_BOX)->EnableWindow(FALSE);
	GetDlgItem(IDC_STATIC_CUT)->EnableWindow(FALSE);
	GetDlgItem(IDC_FILE_CUT)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON1_BROWSE)->EnableWindow(FALSE);
	GetDlgItem(IDC_STATIC_SIZE)->EnableWindow(FALSE);
	GetDlgItem(IDC_COMBO_SIZE)->EnableWindow(FALSE);
	
	GetDlgItem(IDC_JOIN_BOX)->EnableWindow(TRUE);
	GetDlgItem(IDC_STATIC_JOIN_START)->EnableWindow(TRUE);
	GetDlgItem(IDC_JOIN_START)->EnableWindow(TRUE);
	GetDlgItem(IDC_BUTTON2_BROWSE)->EnableWindow(TRUE);
	
	m_Operation_Button.SetWindowText("Join Files");
}

void CFileCutterDlg::OnOperationButton() 
{
	char wintext[12];
	int CuttingSize;
	
	UpdateData(TRUE);

	int mode = m_Size.GetCurSel();

	if (mode == CB_ERR)
	{
		mode = 5;
		m_Size.SetCurSel(mode);
	}

	CuttingSize = m_CuttingSizes[mode];

	// 1kByte = 1024 Bytes
	// 1MByte = 1024 kBytes
	// ==> 1MByte = 1048576 Bytes

	CFolderDialog *pFolderDlg;

	CString folder;
	folder = "C:\\";

	pFolderDlg = new CFolderDialog(&folder);
	
	m_Operation_Button.GetWindowText(wintext, 11);
	if(strcmp(wintext, "Cut File") == 0)
	{
		pFolderDlg->TitleBar("Save cut files to");
		
		if (pFolderDlg)
		{
			pFolderDlg->DoModal();
			delete pFolderDlg;
		}
		pCut->FileCutOperations(m_Cut_File, CuttingSize, folder);
	}
	else
	{
		pFolderDlg->TitleBar("Save joint file to");

		if (pFolderDlg)
		{
			pFolderDlg->DoModal();
			delete pFolderDlg;
		}	
		pJoin->FileJoinOperations(m_Join_Start_File, folder);
	}
}


